Index: firmware/ShutterController/docs/FactShutter.tex
===================================================================
--- firmware/ShutterController/docs/FactShutter.tex	(revision 14271)
+++ firmware/ShutterController/docs/FactShutter.tex	(revision 14272)
@@ -10,4 +10,6 @@
 \usepackage{multirow}
 \usepackage{eurosym}
+\usepackage{url}
+\usepackage{hyperref}
 % Normal DIN A4 page format
 %
@@ -91,9 +93,25 @@
 \vspace*{40 mm}
 
-\section{\label{sec:1} Introduction}
-The new remote controllable shutter system for the FACT telescope is built around two low voltage 24~V linear actuatorrs from Linak\footnote{Linak AG}
+\section{\label{sec:1} System overview}
+The new remotely controllable shutter system for the FACT telescope is built around two low voltage 24~V linear actuators from Linak\footnote{Linak AG} driven by two VHN-5019 motor driver which are controlled by an Arduino Ethernet micro controller board.
 
-The two motors are connected to a dual VHN-5019 motor driver Arduino shield which is able to control simultaneously 2 mid-high power motors using Pulse Width Modulation (PWM). The VHN-5019 also grant the possibility of performing current sensing on the A0/A1 pins of the Arduino board. The current sensing coefficient is 0.14 V/A and for this reason, in view of low current measurement, two 10x amplifiers followed by each followed by a low pass 2$^{nd}$ \mbox{($\nu_{cut}=1~$ kHz)} Butterworth filter were included on a custom circuit mounted as an Arduino shield.
+The Arduino is an open-source electronics prototyping platform based on the ATmega AVR micro-controller line. We chose the {\bf Arduino Ethernet} model which mounts a ATmega328 micro-controller with has 32 KB of ROM  and 2 KB of SRAM and already includes a 10 Mbit ethernet interface (WizNet W5100 chipset).
 
+The Arduino boards feature a bus like structure on the sides where composed by two lines of pass through connectors where  Arduino compatible boars (shields) can be plugged in. Arduino shields are normally stackable
+and more shields can be mounted on one controller, provided that their pinout are compatibles.
+\begin{figure}[b!]
+\centering
+\includegraphics[width=1\textwidth]{shutter_sketch.pdf}
+\caption{\label{figShutterSketch} {Sketch of the shutter system}}
+\end{figure}
+
+A sketch of the new shutter system is shown in Fig.\ref{figShutterSketch}. The two motors are connected to an Arduino\cite{arduino} shield which contains two VHN-5019 motor drivers which also enable current sensing. A filter/amplifier shield has been developed to reduce the noise  on the position sensor and on the current measurement which is mainly caused by the length of the cables to the telescope (about 35 m).
+
+The firmware can be uploaded in the Arduino through a standard RS232 serial port although an USB to Serial converter adapter is provided with the board. The firmware which is currently uploaded provide a simple web server with two button linked to the opening and closing commands of the shutter.
+
+\subsection{The motor controller board}
+The motor controller shield is a {\bf Pololu Dual VNH5019 Motor Driver Shield\footnote{\href{http://www.pololu.com/catalog/product/2502}{http://www.pololu.com/catalog/product/2502}}}. The schematic of the shield and the layout of the connection are shown in Fig.\ref{figMotorShield} and Fig.\ref{figMotorShieldUse} respectively.
+
+Each of the VHN-5019 is able to control a mid-high power motor using Pulse Width Modulation (PWM) and, in addition, grants the possibility of performing current sensing on the A0 (M1CS signal) and A1 (M2CS signal) pins of the Arduino board by embedding a current to voltage converter with a current sensing coefficient of 0.14 V/A. 
 %In view of an - almost - completely remote operability of the FACT telescope the shutter
 
@@ -102,16 +120,36 @@
 %Each lid can move independently by a 55 mm stroke actuator which grant the necessary excursion to reach the $110^{\circ}$ which is required in order no to shadow the camera.
 
+\begin{figure}[b!]
+\centering
+\includegraphics[width=0.8\textwidth]{pololu_sch_small.png}
+\caption{\label{figMotorShield} {Diagram of the dual VHN5019 motor driver Arduino shield}}
+\end{figure}
+\begin{figure}[t!]
+\centering
+\includegraphics[width=0.6\textwidth]{pololu_use.jpg}
+\caption{\label{figMotorShieldUse} {Connection layout of the dual VHN5019 motor driver Arduino shield}}
+\end{figure}
+\subsection{Amplifier and filter shield}
+In view of low current measurement, two 10x amplifiers followed by each preceded by a low pass 2$^{nd}$ \mbox{($\nu_{cut}=1~$ kHz)} Butterworth filters were included on a custom circuit mounted as an Arduino shield. The diagram of the filter/amplifier Arduino shield is shown in Fig.\ref{figFilterShield}. The input current sensing signal is taken from the A0 and A1 analog Arduino pins while the amplified and filtered output is fed on the A4 and A5 analog pins respectively.
+
+The analog signals of the Hall position sensors are also fed a low pass 2$^{nd}$ \mbox{($\nu_{cut}=1~$ kHz)} Butterworth filters and their output is connected to the A2/A3 analog Arduino pins.
+
+\begin{figure}[t!]
+\centering
+\includegraphics[width=1\textwidth]{dpnc303_sch.pdf}
+\caption{\label{figFilterShield} {Diagram of the custom filter/amplifier Arduino shield}}
+\end{figure}
 
 
-\begin{figure}[b!]
-\centering
-\includegraphics[width=1\textwidth]{shutter_sketch.pdf}
-\caption{\label{fig1} {Sketch of the shutter system}}
-\end{figure}
+\clearpage
 
-\section{Diagram of the filter board}
+%\section{Diagram of the filter board}
 
-\section{Logic Block of the firmware}
+%\section{Logic Block of the firmware}
 
-\section{The preliminary web interface}
+%\section{The preliminary web interface}
+\begin{thebibliography}{50}
+\small
+\bibitem{arduino} \href{http://www.arduino.cc}{http://www.arduino.cc}
+\end{thebibliography}
 \end{document}