Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track1218Wobble1.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track1218Wobble1.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track1218Wobble1.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 1
->...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 .s DRIVE_CONTROL 6
 > DRIVE: ARMED
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track1218Wobble2.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track1218Wobble2.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track1218Wobble2.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 2
->...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 .s DRIVE_CONTROL 6
 > DRIVE: ARMED
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track2344Wobble1.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track2344Wobble1.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track2344Wobble1.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 1
->...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 DRIVE_CONTROL/STOP
 .s DRIVE_CONTROL 6
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track2344Wobble2.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track2344Wobble2.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/Track2344Wobble2.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 2
-> ...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 DRIVE_CONTROL/STOP
 .s DRIVE_CONTROL 6
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble1.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble1.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble1.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 1
->...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 .s DRIVE_CONTROL 6
 > DRIVE: ARMED
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble2.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble2.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackCrabWobble2.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 2
->...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 .s DRIVE_CONTROL 6
 > DRIVE: ARMED
@@ -13,4 +15,4 @@
 
 DRIVE_CONTROL/TRACK_SOURCE 0.6 -130 Crab
->...sent tracking command for Crab Wobble 2
+> ...sent tracking command for Crab Wobble 2
 > COMMAND: DRIVE_CONTROL/TRACK_SOURCE 0.6 -130 Crab
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble1.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble1.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble1.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 1
->...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 DRIVE_CONTROL/STOP
 .s DRIVE_CONTROL 6
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble2.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble2.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk421Wobble2.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 2
-> ...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 DRIVE_CONTROL/STOP
 .s DRIVE_CONTROL 6
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk501Wobble1.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk501Wobble1.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk501Wobble1.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 1
->...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 DRIVE_CONTROL/STOP
 .s DRIVE_CONTROL 6
Index: trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk501Wobble2.dim
===================================================================
--- trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk501Wobble2.dim	(revision 14411)
+++ trunk/FACT++/ScriptsForDimCtrl/ServiceScripts/TrackMrk501Wobble2.dim	(revision 14412)
@@ -7,5 +7,7 @@
 >
 > moving telescope to wobble position 2
-> ...waiting for drivectrl to be ready to move
+> ...waiting for DRIVE_CONTROL
+>    to be in state 6: Armed
+
 DRIVE_CONTROL/STOP
 .s DRIVE_CONTROL 6